DPDK patches and discussions
 help / color / mirror / Atom feed
From: Thomas Monjalon <thomas.monjalon@6wind.com>
To: dev@dpdk.org
Subject: [dpdk-dev] [PATCH v2 1/2] scripts: add checkpatch wrapper
Date: Mon, 23 Nov 2015 02:40:07 +0100	[thread overview]
Message-ID: <1448242808-16101-2-git-send-email-thomas.monjalon@6wind.com> (raw)
In-Reply-To: <1448242808-16101-1-git-send-email-thomas.monjalon@6wind.com>

This script can be used to call checkpatch.pl from Linux with some
custom DPDK options.

The path to the original Linux script must be set in an environment
variable. A script is added to load any configuration variables
required by development tools from a file .develconfig, or
~/.config/dpdk/devel.config or /etc/dpdk/devel.config.

Signed-off-by: Thomas Monjalon <thomas.monjalon@6wind.com>
---
v2:
- do not ignore COMPLEX_MACRO
- use option --no-tree to avoid silent failure
- add -q and -v options

 scripts/checkpatches.sh      | 82 ++++++++++++++++++++++++++++++++++++++++++++
 scripts/load-devel-config.sh | 14 ++++++++
 2 files changed, 96 insertions(+)
 create mode 100755 scripts/checkpatches.sh
 create mode 100755 scripts/load-devel-config.sh

diff --git a/scripts/checkpatches.sh b/scripts/checkpatches.sh
new file mode 100755
index 0000000..afc611b
--- /dev/null
+++ b/scripts/checkpatches.sh
@@ -0,0 +1,82 @@
+#! /bin/sh
+
+# BSD LICENSE
+#
+# Copyright 2015 6WIND S.A.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+#   * Redistributions of source code must retain the above copyright
+#     notice, this list of conditions and the following disclaimer.
+#   * Redistributions in binary form must reproduce the above copyright
+#     notice, this list of conditions and the following disclaimer in
+#     the documentation and/or other materials provided with the
+#     distribution.
+#   * Neither the name of 6WIND S.A. nor the names of its
+#     contributors may be used to endorse or promote products derived
+#     from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Load config options:
+# - DPDK_CHECKPATCH_PATH
+# - DPDK_CHECKPATCH_LINE_LENGTH
+. scripts/load-devel-config.sh
+if [ ! -x "$DPDK_CHECKPATCH_PATH" ] ; then
+	echo 'Cannot execute DPDK_CHECKPATCH_PATH' >&2
+	exit 1
+fi
+
+length=${DPDK_CHECKPATCH_LINE_LENGTH:-80}
+
+# override default Linux options
+options="--no-tree"
+options="$options --max-line-length=$length"
+options="$options --show-types"
+options="$options --ignore=LINUX_VERSION_CODE,FILE_PATH_CHANGES,\
+VOLATILE,PREFER_PACKED,PREFER_ALIGNED,PREFER_PRINTF,PREFER_KERNEL_TYPES,\
+SPLIT_STRING,LINE_SPACING,PARENTHESIS_ALIGNMENT,NETWORKING_BLOCK_COMMENT_STYLE,\
+NEW_TYPEDEFS,COMPARISON_TO_NULL"
+
+print_usage () {
+	echo "usage: $(basename $0) [-q] [-v] [patch1 [patch2] ...]]"
+}
+
+quiet=false
+verbose=false
+while getopts hqv ARG ; do
+	case $ARG in
+		q ) quiet=true ;;
+		v ) verbose=true ;;
+		h ) print_usage ; exit 0 ;;
+		? ) print_usage ; exit 1 ;;
+	esac
+done
+shift $(($OPTIND - 1))
+
+status=0
+for p in "$@" ; do
+	! $verbose || printf '\n### %s\n\n' "$p"
+	report=$($DPDK_CHECKPATCH_PATH $options "$p" 2>/dev/null)
+	[ $? -ne 0 ] || continue
+	$verbose || printf '\n### %s\n\n' "$p"
+	printf '%s\n' "$report" | head -n -6
+	status=$(($status + 1))
+done
+pass=$(($# - $status))
+$quiet || printf '%d/%d valid patch' $pass $#
+$quiet || [ $pass -le 1 ] || printf 'es'
+$quiet || printf '\n'
+exit $status
diff --git a/scripts/load-devel-config.sh b/scripts/load-devel-config.sh
new file mode 100755
index 0000000..489f007
--- /dev/null
+++ b/scripts/load-devel-config.sh
@@ -0,0 +1,14 @@
+#! /bin/echo must be loaded with .
+
+# Load DPDK devel config and allow override
+# from system file
+test ! -r /etc/dpdk/devel.config ||
+        . /etc/dpdk/devel.config
+# from user file
+test ! -r ~/.config/dpdk/devel.config ||
+        . ~/.config/dpdk/devel.config
+# from local file
+test ! -r $(dirname $(readlink -m $0))/../.develconfig ||
+        . $(dirname $(readlink -m $0))/../.develconfig
+
+# The config files must export variables in the shell style
-- 
2.5.2

  reply	other threads:[~2015-11-23  1:41 UTC|newest]

Thread overview: 27+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2015-10-23 15:53 [dpdk-dev] [PATCH 0/2] more basic tests Thomas Monjalon
2015-10-23 15:53 ` [dpdk-dev] [PATCH 1/2] scripts: add checkpatch wrapper Thomas Monjalon
2015-10-23 16:03   ` Stephen Hemminger
2015-10-23 16:34     ` Thomas Monjalon
2015-10-23 16:56       ` Stephen Hemminger
2015-10-23 16:58       ` Stephen Hemminger
2015-10-23 20:27         ` Thomas Monjalon
2015-10-29 12:17   ` Bruce Richardson
2015-10-29 12:33   ` David Marchand
2015-10-29 13:03     ` Thomas Monjalon
2015-10-29 13:24       ` Bruce Richardson
2015-10-29 13:34         ` Thomas Monjalon
2015-10-29 13:48           ` Bruce Richardson
2015-10-29 13:54             ` David Marchand
2015-10-29 13:57               ` Thomas Monjalon
2015-10-30 16:16                 ` Bruce Richardson
2015-10-30 16:23                   ` Thomas Monjalon
2015-11-02 10:28                     ` Van Haaren, Harry
2015-11-02 10:33                       ` Bruce Richardson
2015-10-23 15:53 ` [dpdk-dev] [PATCH 2/2] scripts: add build tests Thomas Monjalon
2015-11-23  1:40 ` [dpdk-dev] [PATCH v2 0/2] more basic tests Thomas Monjalon
2015-11-23  1:40   ` Thomas Monjalon [this message]
2015-11-24 16:33     ` [dpdk-dev] [PATCH v2 1/2] scripts: add checkpatch wrapper Bruce Richardson
2015-11-23  1:40   ` [dpdk-dev] [PATCH v2 2/2] scripts: add build tests Thomas Monjalon
2015-11-24 17:49     ` Mcnamara, John
2015-11-24 18:14       ` Thomas Monjalon
2015-12-03 17:39   ` [dpdk-dev] [PATCH v2 0/2] more basic tests Thomas Monjalon

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1448242808-16101-2-git-send-email-thomas.monjalon@6wind.com \
    --to=thomas.monjalon@6wind.com \
    --cc=dev@dpdk.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).